package jatva.lang;
import jatva.lang.synchronization.TestManager;

/**
 * Provides handy accessors to attributes of model events.
 *
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public class ModelEventHelper
{
    @SuppressWarnings( "unchecked" )
    public static <T> T getArgument( ModelEvent e, String arg_name )
    {
        int arg_number = -1;
        for( String par_name : e.getOperation().getParNames() )
        {
            arg_number ++;
            if( par_name.equals( arg_name ) )
                break;
        }
        if( arg_number == -1 )
        {
            throw new IllegalArgumentException(   "no arg named "
                                                + "'" + arg_name + "'"
                                                + " found in signature "
                                                + "'" + e.getOperation().getPrettySignature() + "'"
                                              );
        }

        return (T)e.getArguments()[ arg_number ];
    }

    @SuppressWarnings( "unchecked" )
    public static <T> T getArgument( ModelEvent e, int arg_num )
    {
        return (T)e.getArguments()[ arg_num ];
    }

    public static String getOperationName( ModelEvent me )
    {
        return me.getOperation().getMethod().getName();
    }

    public static String getPrettySignature( ModelEvent me )
    {
        return me.getOperation().getPrettySignature();
    }

    public static ModelEvent getCurrentEvent()
    {
        return TestManager.getRegistrar().getCurrentEvent();
    }
}
