/*
 * Copyright (c) 2000 ISP RAS. 109004, B. Communisticheskaya, 25, Moscow,
 * Russia. All rights reserved.
 *
 * $Id: TestException.java,v 1.6 2009/02/19 15:38:01 almo Exp $ Created on
 * 01.04.2000
 */

package jatva.lang;

import jatva.lang.synchronization.Test;
import jatva.lang.synchronization.TestManager;
import jatva.util.Utils;

public class TestException extends Error
{
    protected Throwable _cause = null;

    protected boolean _isCritical = false;

    @Override
    public Throwable getCause()
    {
        return _cause;
    }

    public boolean isCritical()
    {
        return _isCritical;
    }

    protected TestException( String info
                           , Throwable error
                           , boolean isCritical
                           , boolean isInternal
                           , boolean isTraced
                           , String[] tags
                           , String[] values
                           )
    {
        super( info );
        _cause = error;
        _isCritical = isCritical;

        TestManager.getRegistrar().testException( this
                                                , info
                                                , error
                                                , isCritical
                                                , isInternal
                                                , isTraced
                                                , tags
                                                , values
                                                );
    }

    public TestException( String info
                        , Throwable error
                        , boolean isCritical
                        , String[] tags
                        , String[] values
                        )
    {
        this( info, error, isCritical, false, true, tags, values );
    }

    protected TestException( String info
                           , boolean isCritical
                           , String[] tags
                           , String[] values
                           )
    {
        this( info, null, isCritical, false, true, tags, values );
    }

    public TestException( String info
                        , Throwable error
                        , String[] tags
                        , String[] values
                        )
    {
        this( info, error, false, false, true, tags, values );
    }

    public TestException( String info, String[] tags, String[] values )
    {
        this( info, null, false, false, true, tags, values );
    }

    protected static String formatModelObject( ModelObject mo )
    {
        if( TestManager.getRegistrar().getStatus() == Test.CHECKING )
        {
            // we're checking oracles in serialization
            // no 'model object' tags available.
            // so we should print model object deeply
            return Utils.getDeepString( mo );
        } else {
            // we're executing either in synchronous mode
            // or asynchronous one. should print trivial string
            return Utils.getSimpleString( mo );
        }
    }
}
