package jatva.lang.synchronization;

import com.unitesk.jogs.Snapshot;

/**
 * Empty serializer doesn't call any oracles or model state updates
 * and thus accepts any observed behavior.
 *
 * One may need this serializer if using JavaTESK to develope tests
 * in the style of separate test cases. for test cases.
 *
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public final class EmptySerializer extends AbstractSerializer
{
    public static final EmptySerializer prototype = new EmptySerializer();

    private EmptySerializer(){}

    @Override
    protected SerializationResult serialize( Snapshot testStateBeforeFrameSnapshot )
    { return SerializationResult.OK; }

    @Override
    public AbstractSerializer clone()
    { return prototype; }
}
