package jatva.lang.synchronization;

import jatva.lang.ModelEvent;

/**
 * Stores the result of scenario expect-s, i.e. the index of the pattern matched along with
 * the event itself.
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public class EventWaitingResult
{
    private int patternIndex;

    private ModelEvent matchedEvent;

    public int getPatternIndex()
    {
        return patternIndex;
    }

    public ModelEvent getMatchedEvent()
    {
        return matchedEvent;
    }

    public EventWaitingResult( int patternIndex, ModelEvent matchedEvent )
    {
        super();
        this.patternIndex = patternIndex;
        this.matchedEvent = matchedEvent;
    }

    public static final EventWaitingResult TIMEOUT_EXPIRED = new EventWaitingResult( -1, null );
}
