package jatva.util.log;

/**
 * Silent log that suppresses all printing requests.
 *
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public class NullLog extends ThreadLog
{
    private static final NullLog instance = new NullLog();

    public static ThreadLog log()
    { return instance; }

    @Override
    public void print( String ... texts )
    {
    }

    @Override
    protected void printLine( String l )
    {
    }

    @Override
    protected void printFooter()
    {
    }

    @Override
    protected void printHeader()
    {
    }
}
