package jatva.util.log;

/**
 * Trivial implementation of {@link ThreadLog}. In the header this
 * log prints the line of dashes followed by the line with the name
 * of the current thread.
 *
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public class SimpleConsoleLog extends ThreadLog
{
    private SimpleConsoleLog(){}

    private static final SimpleConsoleLog instance = new SimpleConsoleLog();

    public static final SimpleConsoleLog getLog()
    { return instance; }

    protected void printHeader()
    {
        System.out.println( "- - - - - - - - - - - - - - - - - - - - - - - - - - -" );
        System.out.println( "# " + Thread.currentThread().getName() + " #" );
    }

    protected void printFooter()
    {
        System.out.flush();
    }

    @Override
    protected void printLine( String l )
    {
        System.out.println( l );
    }
}
